import { useContext as p, useState as T, useEffect as V } from "react";
import { $ as S, az as I, aA as D, a0 as n, fp as E, a6 as P, P as C, aD as H, w, T as j, a5 as O, a1 as B, fq as M, v as y, U as A, F as o, a9 as c, G as h, aa as d, ab as m, ai as f, ac as F, ad as G, af as g, ae as U, c2 as q, aw as u, dM as z, fr as N, an as W } from "./5ddaced2.js";
import { timelineDate as J, TimelineDataTooltip as K } from "./bc94c7a4.js";
import { convertTimeLineData as Q } from "./f91ce636.js";
import "react-dom";
const R = S.div`
  ${(e) => `margin: ${e.$style.margin ?? "3px"}`};
  ${(e) => `padding: ${e.$style.padding !== "3px" ? e.$style.padding : "20px 10px 0px 10px"}`};
  ${(e) => `width: ${I(e.$style.margin ?? "3px")}`};
  ${(e) => `height: ${D(e.$style.margin ?? "3px")}`};
  ${(e) => `background: ${e.$style.background}`};
  ${(e) => `border-radius: ${e.$style.radius}`};
  overflow: auto;
  overflow-x: hidden;

  .ant-timeline .ant-timeline-item-head {
    background-color: transparent;
  }
`, X = [W], Y = [{
  label: n("timeLine.left"),
  value: "left"
}, {
  label: n("timeLine.right"),
  value: "right"
}, {
  label: n("timeLine.alternate"),
  value: "alternate"
}], Z = {
  value: E(Q, J),
  mode: P(Y, "alternate"),
  reverse: C,
  autoHeight: H,
  verticalScrollbar: w(C, !1),
  pending: w(j, n("timeLine.defaultPending")),
  onEvent: O(X),
  style: B(M, "style"),
  clickedObject: y({
    title: ""
  }),
  clickedIndex: y(0)
}, _ = async (e) => {
  if (!e)
    return null;
  try {
    const r = (await import("./5ddaced2.js").then((i) => i.Gd))[e];
    return r ? /* @__PURE__ */ o(r, {}) : null;
  } catch (l) {
    return console.error(`Error loading icon ${e}:`, l), null;
  }
}, v = (e) => {
  const {
    value: l,
    dispatch: r,
    style: i,
    mode: ee,
    reverse: te,
    onEvent: $
  } = e, [x, L] = T([]);
  V(() => {
    (async () => {
      const a = await Promise.all(l.map((s) => s.dot ? _(s.dot) : Promise.resolve(null)));
      L(a);
    })();
  }, [l]);
  const k = l.map((t, a) => ({
    key: a,
    color: t == null ? void 0 : t.color,
    dot: x[a] || "",
    label: /* @__PURE__ */ o("span", {
      style: {
        color: (t == null ? void 0 : t.labelColor) || (i == null ? void 0 : i.labelColor)
      },
      children: t == null ? void 0 : t.label
    }),
    children: /* @__PURE__ */ c(h, {
      children: [/* @__PURE__ */ o(q, {
        type: "link",
        onClick: (s) => {
          s.preventDefault(), r(u("clickedObject", t, !1)), r(u("clickedIndex", a, !1)), $("click");
        },
        style: {
          cursor: "pointer",
          color: (t == null ? void 0 : t.titleColor) || (i == null ? void 0 : i.titleColor)
        },
        children: /* @__PURE__ */ o("b", {
          children: t == null ? void 0 : t.title
        })
      }), /* @__PURE__ */ o("p", {
        style: {
          color: (t == null ? void 0 : t.subTitleColor) || (i == null ? void 0 : i.subTitleColor)
        },
        children: t == null ? void 0 : t.subTitle
      })]
    })
  }));
  return /* @__PURE__ */ o(z, {
    hideScrollbar: !e.verticalScrollbar,
    children: /* @__PURE__ */ o(R, {
      $style: i,
      children: /* @__PURE__ */ o(N, {
        mode: (e == null ? void 0 : e.mode) || "left",
        reverse: e == null ? void 0 : e.reverse,
        pending: (e == null ? void 0 : e.pending) && /* @__PURE__ */ o("span", {
          style: {
            color: i == null ? void 0 : i.titleColor
          },
          children: (e == null ? void 0 : e.pending) || ""
        }),
        items: k
      })
    })
  });
};
let b = function() {
  return new A(Z, (e, l) => /* @__PURE__ */ o(v, {
    ...e,
    dispatch: l
  })).setPropertyViewFn((e) => /* @__PURE__ */ c(h, {
    children: [/* @__PURE__ */ o(d, {
      name: m.basic,
      children: e.value.propertyView({
        label: n("timeLine.value"),
        tooltip: K,
        placeholder: "[]"
      })
    }), ["logic", "both"].includes(p(f).editorModeStatus) && /* @__PURE__ */ c(d, {
      name: m.interaction,
      children: [e.onEvent.getPropertyView(), F(e)]
    }), ["layout", "both"].includes(p(f).editorModeStatus) && /* @__PURE__ */ c(h, {
      children: [/* @__PURE__ */ c(d, {
        name: m.layout,
        children: [e.autoHeight.getPropertyView(), !e.autoHeight.getView() && e.verticalScrollbar.propertyView({
          label: n("prop.showVerticalScrollbar")
        }), e.mode.propertyView({
          label: n("timeLine.mode"),
          tooltip: n("timeLine.modeTooltip")
        }), e.pending.propertyView({
          label: n("timeLine.pending"),
          tooltip: n("timeLine.pendingDescription")
        }), e.reverse.propertyView({
          label: n("timeLine.reverse")
        })]
      }), /* @__PURE__ */ o(d, {
        name: m.style,
        children: e.style.getPropertyView()
      })]
    })]
  })).build();
}();
b = class extends b {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const ae = G(b, [new g("value", n("timeLine.valueDesc")), new g("clickedObject", n("timeLine.clickedObjectDesc")), new g("clickedIndex", n("timeLine.clickedIndexDesc")), U]);
export {
  ae as TimeLineComp
};
