import { $ as l, dX as w, a0 as n, a7 as f, a5 as y, aD as $, a6 as c, dY as x, w as C, a1 as g, dZ as b, aC as S, da as v, db as k, a9 as a, G as h, aa as i, ab as o, ai as m, ac as V, F as e, dM as A, d_ as T, U as H, ad as z, af as B, ae as p, ay as P, az as E, aA as F, P as M, an as D, aq as N, as as O, ar as W } from "./5ddaced2.js";
import u, { useContext as s } from "react";
import "react-dom";
const R = [D], j = (t) => P`
    border-radius: ${t.radius ? t.radius : "4px"};
    border: ${t.borderWidth ? t.borderWidth : "0px"} ${t.borderStyle ? t.borderStyle : "solid"} ${t.border};
    color: ${t.text};
    text-transform:${t.textTransform} !important;
    text-decoration:${t.textDecoration} !important;
    background: ${t.background};
    .markdown-body a {
      color: ${t.links};
    }
    .markdown-body {
      margin: ${t.margin} !important;	
      padding: ${t.padding};	
      width: ${E(t.margin)};	
      font-family: ${t.fontFamily} !important;
      font-style:${t.fontStyle} !important;
      font-size: ${t.textSize} !important;
      // height: ${F(t.margin)};
      h1 {
        line-height: 1.5;
      }
      h5 {
        line-height: 2.2;
      }
    }

    .markdown-body {
      &,
      p,
      div,
      h1,
      h2,
      h3,
      h4,
      h5,
      h6 {
        color: ${t.text};
        font-weight: ${t.textWeight} !important;
        line-height:${t.lineHeight};
      }
      img,
      pre {
        background-color: ${t.background};
        code {
          color: #000000;
        }
      }
    }
  `, J = l.div`
  height: 100%;
  overflow: auto;
  margin: 0;
  ${(t) => t.$animationStyle}
  ${(t) => t.$type === "text" && `
    white-space:break-spaces;
    line-height: 1.9;
    font-size: ${t.$styleConfig.textSize};
    font-weight: ${t.$styleConfig.textWeight};
    font-style: ${t.$styleConfig.fontStyle};
    font-family: ${t.$styleConfig.fontFamily};
    margin: ${t.$styleConfig.margin};
    padding: ${t.$styleConfig.padding};
  `};
  ${(t) => t.$styleConfig && j(t.$styleConfig)}
  display: flex;
  ${w};
  overflow-wrap: anywhere;
  .markdown-body {
    overflow-wrap: anywhere;
  }
`, U = l(N)`
  transform: rotate(90deg);
`, _ = l(O)`
  transform: rotate(90deg);
`, I = l(W)`
  transform: rotate(90deg);
`, q = [{
  label: "Markdown",
  value: "markdown"
}, {
  label: n("text"),
  value: "text"
}], G = [{
  label: /* @__PURE__ */ e(U, {}),
  value: "flex-start"
}, {
  label: /* @__PURE__ */ e(I, {}),
  value: "center"
}, {
  label: /* @__PURE__ */ e(_, {}),
  value: "flex-end"
}], X = {
  text: f("text", n("textShow.text", {
    name: "{{currentUser.name}}"
  })),
  onEvent: y(R),
  autoHeight: $,
  type: c(q, "markdown"),
  horizontalAlignment: x(),
  contentScrollBar: C(M, !0),
  verticalAlignment: c(G, "center"),
  style: g(b, "style"),
  animationStyle: g(S, "animationStyle"),
  margin: v,
  padding: k
}, Y = u.memo((t) => /* @__PURE__ */ a(h, {
  children: [/* @__PURE__ */ a(i, {
    name: o.basic,
    children: [t.children.type.propertyView({
      label: n("value"),
      tooltip: n("textShow.valueTooltip"),
      radioButton: !0
    }), t.children.text.propertyView({})]
  }), ["logic", "both"].includes(s(m).editorModeStatus) && /* @__PURE__ */ a(i, {
    name: o.interaction,
    children: [V(t.children), t.children.onEvent.getPropertyView()]
  }), ["layout", "both"].includes(s(m).editorModeStatus) && /* @__PURE__ */ a(h, {
    children: [/* @__PURE__ */ a(i, {
      name: o.layout,
      children: [t.children.autoHeight.getPropertyView(), !t.children.autoHeight.getView() && t.children.contentScrollBar.propertyView({
        label: n("prop.contentScrollbar")
      }), !t.children.autoHeight.getView() && t.children.verticalAlignment.propertyView({
        label: n("textShow.verticalAlignment"),
        radioButton: !0
      }), t.children.horizontalAlignment.propertyView({
        label: n("textShow.horizontalAlignment"),
        radioButton: !0
      })]
    }), /* @__PURE__ */ e(i, {
      name: o.style,
      children: t.children.style.getPropertyView()
    }), /* @__PURE__ */ e(i, {
      name: o.animationStyle,
      hasTooltip: !0,
      children: t.children.animationStyle.getPropertyView()
    })]
  })]
})), Z = u.memo((t) => {
  const r = t.text.value;
  return /* @__PURE__ */ e(J, {
    $animationStyle: t.animationStyle,
    $type: t.type,
    $styleConfig: t.style,
    style: {
      justifyContent: t.horizontalAlignment,
      alignItems: t.autoHeight ? "center" : t.verticalAlignment,
      textAlign: t.horizontalAlignment,
      rotate: t.style.rotation
    },
    onClick: () => t.onEvent("click"),
    children: /* @__PURE__ */ e(A, {
      hideScrollbar: !t.contentScrollBar,
      children: t.type === "markdown" ? /* @__PURE__ */ e(T, {
        children: r
      }) : r
    })
  });
}, (t, r) => JSON.stringify(t) === JSON.stringify(r));
let d = function() {
  return new H(X, (t) => /* @__PURE__ */ e(Z, {
    ...t
  })).setPropertyViewFn((t) => /* @__PURE__ */ e(Y, {
    children: t
  })).build();
}();
d = class extends d {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const tt = z(d, [new B("text", n("textShow.textDesc")), p]);
export {
  tt as TextComp
};
