import { Y as g, J as o, eq as p, _ as s, eI as w } from "./5ddaced2.js";
import { MockTableComp as h } from "./6376a911.js";
import { TableComp as x } from "./37470912.js";
import "react";
import "react-dom";
import "./f6d26858.js";
import "./5ee10258.js";
import "./003edba0.js";
import "./99e0f516.js";
import "./105cca41.js";
test("test column", () => {
  const t = {
    title: "name"
    // editable: true, // TODO: change to boolean
  };
  let a = new g({
    value: t
  });
  a = o(a);
  const e = a.getView();
  expect(e.title).toEqual(t.title);
});
test("test column render", () => {
  const t = {
    render: {
      compType: "text",
      comp: {
        text: "{{currentRow.id}}"
      }
    }
    // editable: true, // TODO: change to boolean
  };
  let a = new g({
    value: t
  });
  a = o(a);
  const e = a.getView();
  expect(e.render({
    currentCell: null,
    currentIndex: null,
    currentRow: {
      id: "hello"
    },
    currentOriginalIndex: null
  }, "0").getView().view({}).props.normalView).toEqual("hello");
});
test("test table", async () => {
  const t = {
    data: JSON.stringify([{
      a: 1
    }]),
    columns: [{
      dataIndex: "a",
      hide: !0
    }, {
      title: "custom",
      dataIndex: "",
      isCustom: !0
    }]
  }, a = {
    query1: p({
      data: [{
        q: 1
      }]
    }),
    query2: p({
      data: [{
        q2: 2
      }]
    })
  };
  let e = new x({
    dispatch: (r) => {
      e = o(e.reduce(r), a);
    },
    value: t
  });
  e = o(e);
  let l = e.children.columns.getView();
  expect(l.length).toEqual(2), e = o(e.reduce(e.changeChildAction("data", '[{"a":1, "c":2, "d":3}]'))), await new Promise((r) => setTimeout(r, 20)), l = e.children.columns.getView(), expect(l.length).toEqual(4), expect(l[0].getView().dataIndex).toEqual("a"), expect(l[0].getView().hide).toBe(!0), expect(l[1].getView().title).toEqual("custom"), expect(l[2].getView().title).toEqual("c"), expect(l[3].getView().title).toEqual("d");
}, 1e3);
test("test mock table render", () => {
  let t = new h({});
  t = o(t);
});
test("test table data transform", () => {
  function t(n, c) {
    const i = c.exposingValues.displayData, {
      data: d
    } = c.getProps(), m = c.filterData;
    return expect(d.length).toEqual(3), expect(i.length).toEqual(n), expect(i.map((u) => s.omit(u, "custom"))).toEqual(s.map(m, (u) => s.omit(u, w))), {
      transformedData: m,
      data: d,
      displayData: i
    };
  }
  const a = {
    data: JSON.stringify([{
      id: 1,
      name: "gg"
    }, {
      id: 5,
      name: "gg2"
    }, {
      id: 3,
      name: "jjj"
    }]),
    columns: [{
      dataIndex: "id",
      isCustom: !1,
      sortable: !0,
      render: {
        compType: "text",
        comp: {
          text: "{{currentCell}}"
        }
      }
    }, {
      dataIndex: "name",
      isCustom: !1,
      render: {
        compType: "text",
        comp: {
          text: "{{currentCell}}"
        }
      }
    }, {
      title: "custom",
      dataIndex: "ealekfg",
      isCustom: !0,
      render: {
        compType: "image",
        comp: {
          src: "{{currentRow.id}}"
        }
      }
    }]
  };
  let e = new x({
    dispatch: (n) => {
      e = o(e.reduce(n));
    },
    value: a
  });
  e = o(e), e = o(e.reduce(e.changeChildAction("sort", [{
    column: "id",
    desc: !0
  }])));
  let {
    transformedData: l,
    data: r,
    displayData: f
  } = t(3, e);
  expect(l.map((n) => n.id)).toEqual([5, 3, 1]), e = o(e.reduce(e.changeChildAction("toolbar", {
    searchText: "gg"
  }))), t(2, e), e = o(e.reduce(e.changeChildAction("toolbar", {
    showFilter: !0,
    filter: {
      stackType: "and",
      filters: [{
        columnKey: "id",
        filterValue: "4",
        operator: "gt"
      }, {
        columnKey: "id",
        filterValue: "5",
        operator: "lte"
      }]
    }
  }))), t(1, e);
});
